%define zopeproductsdir %{_libdir}/zope/lib/python/Products
%define productname     CMFBoard
%define productver      2.1.2
%define i18ndomain      cmfboard

%define __find          /usr/bin/find
%define __iconv         /usr/bin/iconv

#
# optional
#
%define __msgfmt        /usr/bin/msgfmt

Name:               zope-%{productname}
Summary:            A Zope product: %{productname} - A powerful forum system running in Plone
Version:            %{productver}
Release:            1ied06
Epoch:              1
Group:              Applications/Internet
Requires:           zope >= 2.7.0
Requires:           zope-CMFPlone >= 2.0
Requires:           zope-Archetypes >= 1.2.5
BuildRequires:      sed
License:            ZPL
URL:                http://www.cmfboard.org
Source:             http://prdownloads.sourceforge.net/collective/%{productname}-%{productver}.tar.gz
Vendor:             IED
Distribution:       Zope
Packager:           Wei He <hewe@ied.org.cn>
BuildRoot:          %{_tmppath}/%{name}-%{version}-root
Buildarch:          noarch
Requires(preun):    %{__find}

Patch0:             %{productname}-2.1-rc1-modpath-fix.patch
Patch1:             %{productname}-2.1.2-skins-i18n-fix.patch
Patch2:             %{productname}-2.1.2-dual-wysiwygeditor.patch
Patch3:             %{productname}-2.1.2-broken-contact-admin.patch
Patch4:             %{productname}-2.1.2-right_slots-bugfix.patch
Patch5:             %{productname}-2.1.2-insert-at-cursor.patch
Source1:            %{productname}-2.1.2-zh_cn.po
Source2:            %{productname}-2.1.2-plone-zh_cn.po

#---------------------------------------------------------------------
%description

A powerful forum system running in Plone.

#----------------------------------------------------------------------
%prep

#
# Convert to utf-8 and install i18n po file
#
# $1 source po file
# $2 destination po file
# $3 sublanguage code (optional)
#
install_i18n() {

    if [ -x "%{__msgfmt}" ]; then
        echo "Testing $1 ..."
        %{__msgfmt} -v -o /dev/null $1 || exit 1
    fi

    CURENC=`%{__sed} -rn 's/^"Content-[tT]ype: .*charset=([^\\]+).*/\L\1/p' "$1"`
    if [ "$CURENC" != "utf-8" ];  then
        %{__iconv} -f $CURENC -t utf-8 "$1" | %{__sed} -r 's/^(\"Content-[tT]ype: .*charset=)[^\\]+(.*)/\1utf-8\2/' > "$2"
    else
        %{__sed} -r 's/^\xef\xbb\xbf//' "$1" > "$2"
    fi

    if [ "$3" != "" ]; then
        %{__sed} -r "s/^(\x22Language-[cC]ode: )[^\\]+(.*)/\1$3\2/" "$2" | %{__grep} -Eiv '^"X-Is-Fallback-For:' > ${2%%-*.po}-$3.po
    fi

}

%setup -q -n %{productname}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%{__mv} VERSION.txt version.txt
%{__rm} i18n/build.bat i18n/msgfmt.exe

# The %{i18ndomain}-plone-zh.po in 2.1.1 is Hong Kong Chinese translation.
#
%{__sed} -r 's/^("Language-[cC]ode: zh)\\/\1-hk\\/' i18n/%{i18ndomain}-plone-zh.po > i18n/%{i18ndomain}-plone-zh-hk.po
install_i18n %{SOURCE1} i18n/%{i18ndomain}-zh.po zh-cn
install_i18n %{SOURCE2} i18n/%{i18ndomain}-plone-zh.po zh-cn

#----------------------------------------------------------------------
%build

#----------------------------------------------------------------------
%install
[ "$RPM_BUILD_ROOT" != "/" ] && %{__rm} -rf $RPM_BUILD_ROOT

%{__mkdir_p}  $RPM_BUILD_ROOT%{zopeproductsdir}/%{productname}
%{__cp} -pr * $RPM_BUILD_ROOT%{zopeproductsdir}/%{productname}

#----------------------------------------------------------------------
%clean
[ "$RPM_BUILD_ROOT" != "/" ] && %{__rm} -rf $RPM_BUILD_ROOT

#----------------------------------------------------------------------
%preun

%{__find} %{zopeproductsdir}/%{productname} -iname *.pyc -exec %{__rm} '{}' \;

#----------------------------------------------------------------------
%files
%defattr(-,root,root,0755)
%doc BUGS.txt  CHANGES.txt  CREDITS.txt  README.txt  TODO.txt version.txt
%dir %{zopeproductsdir}/%{productname}
%{zopeproductsdir}/%{productname}/*

#----------------------------------------------------------------------
%changelog
* Sat Jul 17 2004 Wei He <hewei@ied.org.cn> 2.1.2-1ied06
- insertAtCursor patch missing from previous builds

* Tue Jul  6 2004 Wei He <hewei@ied.org.cn> 2.1.2-1ied05
- updated Simplified Chinese translation
- added several missing items for Simplified Chinese translation
- fixed a bug conflicting with SimplePortlet

* Mon Jul  5 2004 Wei He <hewei@ied.org.cn> 2.1.2-1ied04
- added install_i18n function in spec
- allow using wizards with wysiwyg editor for plain text
- enhanced emoticon inserting by javascript function insertAtCursor
- added 3 missing items for Simplified Chinese translation

* Sat Jul 03 2004 Wei He <hewei@ied.org.cn> 2.1.2-1ied03
- Simplified Chinese po file using gb18030 encoding for easy editing.
  will be converted to utf-8 during build

* Fri Jul 02 2004 Wei He <hewei@ied.org.cn> 2.1.2-1ied02
- updated to 2.1.2
- updated Simplified Chinese translation

* Mon Jun 28 2004 Wei He <hewei@ied.org.cn> 2.1.1-1ied01
- product files' ownership chaned to root
- updated Simplified Chinese translation

* Fri Jun 17 2004 Wei He <hewei@ied.org.cn> 2.1.1-1ied00
- updated to 2.1.1

* Mon May 24 2004 Wei He <hewei@ied.org.cn> 2.1-1ied00
- updated to 2.1final

* Wed May 11 2004 Wei He <hewei@ied.org.cn> 2.1-rc1ied00
- fixed path for using indepent python validator module
- Initial release
